#pragma semicolon 1

#include <sourcemod>
#include <sdktools_functions>
#include <sdktools_entinput>
#include <cstrike>
#include <vip>

#if defined REQUIRE_EXTENSIONS
	#undef REQUIRE_EXTENSIONS
#endif
#include <sdkhooks>

public Plugin:myinfo = 
{
	name	= "VIP [Buy Enemy Weapon]",
	author	= "wS",
	version = "1.1.3"
};

#define WEAPON_LENGTH 32
#define ITEM_NAME "buy_enemy_weapon"

new bool:g_bAccess[MAXPLAYERS + 1];

new Handle:g_hAr = INVALID_HANDLE;	// items, которые есть в g_hTr
new Handle:g_hTr = INVALID_HANDLE;	// Handle:hAr -> 0 = "slot", 1 = "OtherItem1", 2 = "OtherItem2", 3 = "OtherItem3" и тд

new g_Slot[MAXPLAYERS + 1];
new String:g_sItem1[MAXPLAYERS + 1][WEAPON_LENGTH], String:g_sItem2[MAXPLAYERS + 1][WEAPON_LENGTH];
new Float:g_fBuyTime[MAXPLAYERS + 1];
new Handle:g_hIgnoreBuy[MAXPLAYERS + 1];
new bool:g_bCSGO;

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	MarkNativeAsOptional("SDKHook");
	MarkNativeAsOptional("SDKUnhook");
	return APLRes_Success;
}
	
public OnPluginStart()
{
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_TOGGLE))
		SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);

	g_bCSGO = GetEngineVersion() == Engine_CSGO;
	LoadTranslations("vip_modules_description.phrases");
	
	HookEvent	("item_pickup",		item_pickup,	EventHookMode_Post);
	RegAdminCmd	("sm_reload_bew",	sm_reload_bew,	ADMFLAG_ROOT);
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_bAccess[client])
	{
		IntToString(1, ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public bool:VIP_Description(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], String:description[], description_size)
{
	FormatEx(description, description_size, "%T", ITEM_NAME, client);
	return true;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	if (g_bAccess[client]) return VGA_AlreadyEnabled;
	SetStatus(client, true);
	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	SetStatus(client, false);
}

stock SetStatus(client, bool:enabled)
{
	g_bAccess[client] = enabled;
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, enabled);
}

///////////////////////////////////////////////////////////////////////////////////

public OnMapStart()
	reload();

public Action:sm_reload_bew(admin, args)
{
	reload();
	return Plugin_Handled;
}

stock bool:GetWeaponClass(weapon, String:class[], maxlength)
{
	if (!g_bCSGO)
		return GetEntityClassname(weapon, class, maxlength);
	
	switch (GetEntProp(weapon, Prop_Send, "m_iItemDefinitionIndex"))	// csgo выдаёт одинаковый classname для некоторых типов оружия
	{
		case 23: strcopy(class, maxlength, "weapon_mp5sd");				// weapon_mp7		(33)	// buy mp5sd не работает
		case 60: strcopy(class, maxlength, "weapon_m4a1_silencer");		// weapon_m4a1		(16)
		case 61: strcopy(class, maxlength, "weapon_usp_silencer");		// weapon_hkp2000	(32)
		case 63: strcopy(class, maxlength, "weapon_cz75a");				// weapon_p250		(36)	// buy cz75a не работает
		case 64: strcopy(class, maxlength, "weapon_revolver");			// weapon_deagle	(1)		// buy revolver не работает
		default: return GetEntityClassname(weapon, class, maxlength);
	}
	
	return true;
}

public Action:CS_OnBuyCommand(client, const String:weapon[]) 
{
	if (!g_bAccess[client] || !g_hTr || !weapon[0] || g_hIgnoreBuy[client])
		return Plugin_Continue;
	
	decl String:weapon_[WEAPON_LENGTH];
	if (strcopy(weapon_, WEAPON_LENGTH, weapon) < 1 || !xTrimString(weapon_))
		return Plugin_Continue;
	
	decl Handle:hAr;
	if (!GetTrieValue(g_hTr, weapon_, hAr))
		return Plugin_Continue;
	
	// сохраняем имя покупаемого оружия
	strcopy(g_sItem1[client], WEAPON_LENGTH, weapon_);
	
	// slot 0 or 1
	GetArrayString(hAr, 0, weapon_, WEAPON_LENGTH);
	g_Slot[client] = StringToInt(weapon_);
	
	decl String:active_weapon_[WEAPON_LENGTH];
	new i = GetPlayerWeaponSlot(client, g_Slot[client]);
	if (i > MaxClients && GetWeaponClass(i, active_weapon_, WEAPON_LENGTH))
	{
		if (!strcmp(active_weapon_[7], g_sItem1[client], false))
		{
			// Игрок покупает такое же оружие, какое у него сейчас в руках.
			// Останавливаем, т.к. ничего не получится.
			g_sItem1[client][0] = 0;
			return Plugin_Continue;
		}
	}
	else
		active_weapon_[0] = 0;
	
	new Handle:menu = CreateMenu(WeaponMenu_CallBack);
	SetMenuTitle(menu, "VIP\n \n");
	AddMenuItem (menu, g_sItem1[client], g_sItem1[client], ITEMDRAW_DEFAULT);
	i = GetArraySize(hAr);
	
	while (--i > 0)
	{
		GetArrayString(hAr, i, weapon_, WEAPON_LENGTH);
		AddMenuItem(menu, weapon_, weapon_, (!active_weapon_[0] || strcmp(weapon_, active_weapon_[7], true) != 0) ? ITEMDRAW_DEFAULT : ITEMDRAW_DISABLED);
	}
	
	if (g_bCSGO)
	{
		SDKUnhook(client, SDKHook_PostThink, DisableBuyMenuInStupidCSGO);
		SDKHook  (client, SDKHook_PostThink, DisableBuyMenuInStupidCSGO);
		CreateTimer(0.1, EnableBuyMenuInStupidCSGO, client, TIMER_FLAG_NO_MAPCHANGE);
	}
	
	NeedIgnore(client, 0.5);
	
	DisplayMenu(menu, client, 10);
	return Plugin_Handled;
}

public DisableBuyMenuInStupidCSGO(client)
{
    SetEntProp(client, Prop_Send, "m_bInBuyZone", false);
}

public Action:EnableBuyMenuInStupidCSGO(Handle:timer, any:client)
{
	if (IsClientInGame(client)) SDKUnhook(client, SDKHook_PostThink, DisableBuyMenuInStupidCSGO);
	return Plugin_Stop;
}

public WeaponMenu_CallBack(Handle:menu, MenuAction:action, client, item)
{
	if (action == MenuAction_End)
		CloseHandle(menu);

	else if (action == MenuAction_Select && g_bAccess[client] && GetEntProp(client, Prop_Send, "m_bInBuyZone") && IsPlayerAlive(client) && GetMenuItem(menu, item, g_sItem2[client], WEAPON_LENGTH))
	{
		// g_sItem1 = что покупал
		// g_sItem2 = что выбрал в меню
		
		g_fBuyTime[client] = !strcmp(g_sItem1[client], g_sItem2[client], false) ? 0.0 : GetGameTime();
		
		// Продолжаем покупку, которую игрок совершал, при этом временно игнорируя хук покупки.
		// Если он выбрал не то оружие, которое покупал, то в item_pickup отслеживаем поднятие g_sItem1 и меняем его на g_sItem2.
		
		if (g_bCSGO) // задолбал
		{
			if (	 !strcmp(g_sItem1[client], "revolver",	true)) // Ну почему buy revolver не работает? Ненормальный ты, csgo.
				strcopy(g_sItem1[client], WEAPON_LENGTH,	"deagle");
			else if (!strcmp(g_sItem1[client], "cz75a",		true))
				strcopy(g_sItem1[client], WEAPON_LENGTH,	"p250");
			else if (!strcmp(g_sItem1[client], "mp5sd",		true))
				strcopy(g_sItem1[client], WEAPON_LENGTH,	"mp7");
		}
		
		NeedIgnore(client, 0.1);
		FakeClientCommand(client, "buy %s", g_sItem1[client]);
	}
}

stock NeedIgnore(client, Float:fSec)
{
	if (g_hIgnoreBuy[client]) KillTimer(g_hIgnoreBuy[client]);
	g_hIgnoreBuy[client] = CreateTimer(fSec, NotNeedIgnore, client);
}

public Action:NotNeedIgnore(Handle:timer, any:client)
{
	g_hIgnoreBuy[client] = INVALID_HANDLE;
	return Plugin_Stop;
}

public item_pickup(Handle:event, const String:name[], bool:silent)
{
	if (!g_hTr)
		return;
	
	decl client;
	if (g_bAccess[(client = GetClientOfUserId(GetEventInt(event, "userid")))] && (GetGameTime() - g_fBuyTime[client]) < 0.02)
	{
		decl String:weapon_[WEAPON_LENGTH];
		GetEventString(event, "item", weapon_, sizeof(weapon_));
		
		if (!strcmp(weapon_, g_sItem1[client], false)) // Покупал g_sItem1, но выбрал в меню g_sItem2, поэтому выдаём g_sItem2.
		{
			g_fBuyTime[client] = 0.0;
			new weapon = GetPlayerWeaponSlot(client, g_Slot[client]);
			if (weapon > MaxClients)
			{
				RemovePlayerItem (client, weapon);
				AcceptEntityInput(weapon, "Kill");
			}
			FormatEx(weapon_, sizeof(weapon_), "weapon_%s", g_sItem2[client]);
			GivePlayerItem(client, weapon_);
		}
	}
}

///

reload()
{
	if (g_hAr == INVALID_HANDLE)
	{
		g_hAr = CreateArray(WEAPON_LENGTH);
		g_hTr = CreateTrie();
	}
	else
	{
		decl String:sItem[WEAPON_LENGTH], Handle:hAr;
		new i = GetArraySize(g_hAr);
		while (--i > -1)
		{
			GetArrayString(g_hAr, i, sItem, WEAPON_LENGTH);
			if (GetTrieValue(g_hTr, sItem, hAr)) CloseHandle(hAr);
		}
		ClearArray(g_hAr);
		ClearTrie (g_hTr);
	}

	new Handle:kv = CreateKeyValues("buy_enemy_weapon");
	if (FileToKeyValues(kv, "cfg/vip/modules/buy_enemy_weapon/buy_enemy_weapon.txt") && KvGotoFirstSubKey(kv, false))
	{
		decl String:sItem1[WEAPON_LENGTH], String:sItem2[WEAPON_LENGTH], slot1, slot2;
		new Handle:t = WeaponListTrie();
		do
		{
			if (KvGetSectionName(kv, sItem1, WEAPON_LENGTH) && xTrimString(sItem1) && GetTrieValue(t, sItem1, slot1))
			{
				KvGetString( kv, "", sItem2, WEAPON_LENGTH);
				if (xTrimString(sItem2) && GetTrieValue(t, sItem2, slot2) && slot1 == slot2 && strcmp(sItem1, sItem2, false) != 0)
				{
					AddWeapon(sItem1, sItem2, slot1);
					AddWeapon(sItem2, sItem1, slot1);
				}
			}
		}
		while (KvGotoNextKey(kv, false));
		CloseHandle(t);
	}
	CloseHandle(kv);

	if (GetArraySize(g_hAr) < 1) // кодировку опять сломали xD
	{
		CloseHandle(g_hAr);
		CloseHandle(g_hTr);
		g_hAr = INVALID_HANDLE;
		g_hTr = INVALID_HANDLE;
	}
}

stock AddWeapon(const String:sItem1[], const String:sItem2[], slot)
{
	if (FindStringInArray(g_hAr, sItem1) < 0)
		PushArrayString(g_hAr, sItem1);

	decl Handle:hAr;
	if (!GetTrieValue(g_hTr, sItem1, hAr))
	{
		hAr = CreateArray(WEAPON_LENGTH);
		decl String:sSlot[4];
		IntToString(slot,  sSlot, sizeof(sSlot));
		PushArrayString(hAr,  sSlot);
		PushArrayString(hAr, sItem2);
		SetTrieValue(g_hTr, sItem1, hAr);
	}
	else if (FindStringInArray(hAr, sItem2) < 0)
		PushArrayString(hAr, sItem2);
}

stock bool:xTrimString(String:s[])
{
	new i = TrimString(s);
	if (i < 1) return false;
	while (--i > -1) s[i] = CharToLower(s[i]);
	return true;
}

stock Handle:WeaponListTrie()
{
	new Handle:t = CreateTrie();

	SetTrieValue(t, "ak47",			0);
	SetTrieValue(t, "aug",			0);
	SetTrieValue(t, "awp",			0);
	SetTrieValue(t, "famas",		0);
	SetTrieValue(t, "g3sg1",		0);
	SetTrieValue(t, "m249",			0);
	SetTrieValue(t, "m4a1",			0);
	SetTrieValue(t, "mac10",		0);
	SetTrieValue(t, "p90",			0);
	SetTrieValue(t, "ump45",		0);
	SetTrieValue(t, "xm1014",		0);

	SetTrieValue(t, "deagle",		1);
	SetTrieValue(t, "elite",		1);
	SetTrieValue(t, "fiveseven",	1);
	SetTrieValue(t, "glock",		1);
	
	if (g_bCSGO)
	{
		SetTrieValue(t, "galilar",		0);
		SetTrieValue(t, "bizon",		0);
		SetTrieValue(t, "m4a1_silencer",0);
		SetTrieValue(t, "mag7",			0);
		SetTrieValue(t, "mp5sd",		0);
		SetTrieValue(t, "mp7",			0);
		SetTrieValue(t, "mp9",			0);
		SetTrieValue(t, "negev",		0);
		SetTrieValue(t, "nova",			0);
		SetTrieValue(t, "sawedoff",		0);
		SetTrieValue(t, "scar20",		0);
		SetTrieValue(t, "sg556",		0);
		SetTrieValue(t, "ssg08",		0);
		
		SetTrieValue(t, "hkp2000",		1);
		SetTrieValue(t, "tec9",			1);
		SetTrieValue(t, "usp_silencer",	1);
		SetTrieValue(t, "cz75a",		1);
		SetTrieValue(t, "revolver",		1);
		SetTrieValue(t, "p250",			1);
	}
	else
	{
		SetTrieValue(t, "galil",		0);
		SetTrieValue(t, "m3",			0);
		SetTrieValue(t, "mp5navy",		0);
		SetTrieValue(t, "scout",		0);
		SetTrieValue(t, "sg550",		0);
		SetTrieValue(t, "sg552",		0);
		SetTrieValue(t, "tmp",			0);
		
		SetTrieValue(t, "usp",			1);
		SetTrieValue(t, "p228",			1);
	}
	
	return t;
}

public OnClientDisconnect_Post(client)
{
	g_bAccess [client] = false;
	g_fBuyTime[client] = 0.0;
}